package com.esignlive.guidance.forum;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import com.silanis.esl.sdk.DocumentVisibilityConfiguration;
import com.silanis.esl.sdk.EslClient;
import com.silanis.esl.sdk.PackageId;
import com.silanis.esl.sdk.builder.DocumentVisibilityBuilder;
import com.silanis.esl.sdk.builder.DocumentVisibilityConfigurationBuilder;

import lombok.AllArgsConstructor;
import lombok.Getter;
import lombok.Setter;

public class _22_09_15_document_visibility {
    public static final String API_KEY = "QVRRT1xxxA4TA==";
    public static final String API_URL = "https://sandbox.esignlive.com/api"; 
 
	static {
		System.setProperty("java.util.logging.config.file", "./sources/logging.properties");
	}
    
    public static void main( String[] args ) throws IOException {
    	EslClient eslClient = new EslClient( API_KEY, API_URL );

        List<DocumentVisibilityConfiguration> configurations = new ArrayList<>();
        
        List<Document> documents = new ArrayList<>();
        documents.add(new Document("default-consent",Arrays.asList("a82823f5-f22b-47f8-9604-1e7f5e4bc6ef","e6f40361-1db7-498e-bfe6-475fd22f6778")));
        documents.add(new Document("879932eb98a30a675e5440940a686b6b0bf1b9c06709b81e",Arrays.asList("a82823f5-f22b-47f8-9604-1e7f5e4bc6ef")));
        documents.add(new Document("095b106a8039145ba67688dfbec97a3c715064e499ed9464",Arrays.asList("e6f40361-1db7-498e-bfe6-475fd22f6778")));
        
        PackageId packageId = new PackageId("4Ho3kLn4sC4RR1yNVQHrCzALIcQ=");
        
        for(Document document : documents) {
            if(document.getViewers() != null) {
                configurations.add(DocumentVisibilityConfigurationBuilder
                        .newDocumentVisibilityConfiguration(document.getId())
                        .withSignerIds(document.getViewers())
                        .build());
            }
        }
        
        if(!configurations.isEmpty()) {
            eslClient.configureDocumentVisibility(packageId, DocumentVisibilityBuilder
                    .newDocumentVisibility()
                    .withConfigurations(configurations).build());
        }
        
        eslClient.sendPackage(packageId);
    }
    
}

@Getter@Setter@AllArgsConstructor
class Document{
	String id;
	List<String> viewers = new ArrayList<>();
}